//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------

#include <tigcclib.h>
#include <extgraph.h>
#include "menulib.h"

#include "bkgm.h"

//-----------------------------------------------------------------------------

extern unsigned short tiles_Data[54] ;
extern unsigned short fleche_data[180];
extern unsigned short cursor_data[45];
extern unsigned short dices_data[96];

extern unsigned char Tile_Round[8];
extern unsigned char Tile_Cross[8] ;

//-----------------------------------------------------------------------------

extern TMenu * Menu;
enum {ME_MAIN,ME_PAUSE,ME_OPTIONS};

//--------------------------------------------------------------------------

char * player_str[] = {"Human","CPU"};
char * yesno_str[] = {"No","Yes"};

//--------------------------------------------------------------------------

TBoard *Board;

char *Plane0;
char *Plane1;

//-----------------------------------------------------------------------------


// Function 'WaitForMillis' From Ti-Chess by Thomas Nussbaumer
void WaitForMillis(unsigned short n)
{
  asm("
		boucle:
		move.w	#1020,%%d0
		boucle2:
		dbra	%%d0,boucle2
		dbra	%0,boucle
	"::"d"(n):"d0");
}
//-----------------------------------------------------------------------------

void CC_Wait(int n)
{
	if (!Board->cc_delay)
	return;
	WaitForMillis(n);
}
//-----------------------------------------------------------------------------

void NewGame(void)
{
	Board->turn=0;
	
	int f,b;
	for (f=0;f<28;f++)
	for (b=0;b<2;b++)
	Board->Fleches[f].Count[b]=0;
	
	
	Board->Fleches[1].Count[C_WHITE]=2;
	Board->Fleches[6].Count[C_BLUE]=5;
	Board->Fleches[9].Count[C_BLUE]=3;
	Board->Fleches[13].Count[C_WHITE]=5;
	
	Board->Fleches[14].Count[C_BLUE]=5;
	Board->Fleches[18].Count[C_WHITE]=3;
	Board->Fleches[21].Count[C_WHITE]=5;
	Board->Fleches[26].Count[C_BLUE]=2;
	
	Board->cursor_pos=7;
	
	BeginTurn();
	
	
}
//-----------------------------------------------------------------------------

void RollDices(void)
{
	
	Board->Dices[0]=1+random(6);
	Board->Dices[1]=1+random(6);
	
	Board->DiceNum[0]=1;
	Board->DiceNum[1]=1;
	
	if (Board->Dices[0]==Board->Dices[1])
	{
		Board->DiceNum[0]=2;
		Board->DiceNum[1]=2;
	}
}
//-----------------------------------------------------------------------------

void GetValidMoves(void)
{
	
	int a;
	
	// JanCount
	
	Board->JanCount[0]=0;
	for (a=0;a<=6;a++)
	Board->JanCount[0]+=Board->Fleches[a].Count[0];
	
	Board->JanCount[1]=0;
	for (a=21;a<=27;a++)
	Board->JanCount[1]+=Board->Fleches[a].Count[1];
	
	// BearOff_LePlusLoin
	
	for (a=1;a<=6;a++)
	if (Board->Fleches[a].Count[0])
	Board->BearOff_LePlusLoin[0]=a;
	
	for (a=26;a>=21;a--)
	if (Board->Fleches[a].Count[1])
	Board->BearOff_LePlusLoin[1]=a;
	
	// ValidMoves
	
	Board->ValidMoves.Count=0;
	
	if (Board->win_state)
	return;
	
	int f;
	for (f=0;f<28;f++)
	GetValidDests(f);
	
}
//-----------------------------------------------------------------------------

void GetValidDests(int f1)
{
	
	if (f1==0 || f1==27)
	return;
	
	if (!Board->Fleches[f1].Count[Board->turn])
	return;
	
	int double_jet=(Board->Dices[0]==Board->Dices[1]);
	
	// BAR
	int bar_fleche=(Board->turn?FL_BAR1:FL_BAR0);
	int bar_count=Board->Fleches[bar_fleche].Count[Board->turn];
	
	if (bar_count && f1!=bar_fleche)
	return;
	
	AddValidMove(f1,0,1);
	if (!(double_jet && Board->DiceNum[1]!=0))
	AddValidMove(f1,1,0);
	
}
//-----------------------------------------------------------------------------

void AddValidMove(int f1, int dc0, int dc1)
{
	if (dc0>Board->DiceNum[0] || dc1>Board->DiceNum[1])
	return;
	
	// BAR
	int bar_fleche=(Board->turn?FL_BAR1:FL_BAR0);
	int bar_count=Board->Fleches[bar_fleche].Count[Board->turn];
	
	int mul_turn=(Board->turn?1:-1);
	int fs=((bar_count && f1==bar_fleche)?(Board->turn?0:27):f1);
	int f2=AddToFleche(fs,mul_turn*(dc0*Board->Dices[0]+dc1*Board->Dices[1]));
	
	// BEAR OFF
	int bear_off=(Board->JanCount[Board->turn]==15);
	
	// range
	
	int fmin=0;
	int fmax=0;
	
	if (bear_off && Board->turn==0)
	{
		if (f2<0 && f1==Board->BearOff_LePlusLoin[0]) f2=0;
		fmin=0;fmax=26;
	}
	else if (bear_off && Board->turn==1)
	{
		if (f2>27 && f1==Board->BearOff_LePlusLoin[1]) f2=27;
		fmin=1;fmax=27;
	}
	else
	{
		fmin=1;fmax=26;
	}
	
	if (!(f2>=fmin && f2<=fmax))
	return;
	
	int f_count=Board->Fleches[f2].Count[Board->turn^1];
	
	// add dest
	
	
	if (f_count<=1)
	{
		TValidMove*vm=&Board->ValidMoves.ValidMove[Board->ValidMoves.Count];
		
		vm->src=f1;
		vm->dest=f2;
		vm->DiceCount[0]=dc0;
		vm->DiceCount[1]=dc1;
		vm->hit=f_count;
		
		Board->ValidMoves.Count++;
	}
	
}
//-----------------------------------------------------------------------------

int AddToFleche(int f, int d)
{
	int s=d>0?1:-1;
	
	int a;
	for (a=0;a<abs(d);a++)
	{
		f+=s;
		if (f==FL_BAR0 || f==FL_BAR1)
		f+=s;
	}
	
	return f;
}
//-----------------------------------------------------------------------------

TValidMove* GetValidMove(int src, int dest)
{
	int a;
	for (a=0;a<Board->ValidMoves.Count;a++)
	{
		TValidMove*vm=&Board->ValidMoves.ValidMove[a];
		if (vm->src==src && vm->dest==dest)
		return vm;
	}
	
	
	return NULL;
}
//-----------------------------------------------------------------------------

void MovePiece(int src, int dest)
{
	TValidMove*vm=GetValidMove(src,dest);
	
	if (!vm)
	return;
	
	
	int fleche1=src;
	int fleche2=dest;
	
	Board->Fleches[fleche1].Count[Board->turn]--;
	Board->Fleches[fleche2].Count[Board->turn]++;
	
	if (vm->hit)
	{
		Board->Fleches[fleche2].Count[Board->turn^1]--;
		Board->Fleches[Board->turn?FL_BAR0:FL_BAR1].Count[Board->turn^1]++;
	}
	
	Board->DiceNum[0]-=vm->DiceCount[0];
	Board->DiceNum[1]-=vm->DiceCount[1];
	
	// win_state
	
	int win_state_OLD=Board->win_state;
	Board->win_state=(Board->Fleches[0].Count[0]==15 || Board->Fleches[27].Count[1]==15);
	
	if (Board->win_state!=win_state_OLD && Board->win_state)
	{
		RefreshScreen();
		
		char buffer[50];
		sprintf(buffer,"Player%d wins!",Board->turn+1);
		ShowMessage(buffer);
	}
	
	// change turn
	if (Board->DiceNum[0]==0 && Board->DiceNum[1]==0)
	{
	Board->turn^=1;
	BeginTurn();
	}
	else
	BeginNewMove();
	
}
//-----------------------------------------------------------------------------

void BeginTurn(void)
{
	
	Board->move_step=0;
	
	RollDices();
	BeginNewMove();
}
//-----------------------------------------------------------------------------

void BeginNewMove(void)
{
	
	Board->win_state=(Board->Fleches[0].Count[0]==15 || Board->Fleches[27].Count[1]==15);
	GetValidMoves();
	
}
//-----------------------------------------------------------------------------


int GetFlecheX(int f)
{
	if (f>13)
	f=27-f;
	
	int x=9*f;
	
	if ((f>=1 && f<=6))
	x+=1;
	else if (f==7)
	x+=2;
	else if (f>=8 && f<=13)
	x+=3;
	
	return x;
}
//-----------------------------------------------------------------------------

int GetFlecheYY(int f)
{
	return (f<=13)?0:1;
}
//-----------------------------------------------------------------------------

void OnPressF1(void)
{

		if (Board->move_step==0)
		{
			Board->move_step++;
			Board->move_src=Board->cursor_pos;
		}
		else
		{
			Board->move_step=0;
			Board->move_dest=Board->cursor_pos;
			
			MovePiece(Board->move_src,Board->move_dest);
			
		}

}
//-----------------------------------------------------------------------------

void OnSkipTurn(void)
{
	
	char buffer[50];
	
	// must pass
	if (!Board->ValidMoves.Count)
	{
		sprintf(buffer,"Player%d passes!",Board->turn+1);
		ShowMessage(buffer);
		Board->turn^=1;
		BeginTurn();
	}
	else
	{
		ShowMessage("Keep looking!");
	}
}
//-----------------------------------------------------------------------------

void CC_MoveCursor(int f2)
{
	int *f1=&Board->cursor_pos;
	
	
	if (((*f1)<=13 && f2>13) || (f2<=13 && (*f1)>13))
	{
		(*f1)=27-(*f1);
		RefreshScreen();
		CC_Wait(200);
	}
	
	
	while ((*f1)!=f2)
	{
		(*f1)<f2?(*f1)++:(*f1)--;
		RefreshScreen();
		CC_Wait(200);
	}
	
	
}
//-----------------------------------------------------------------------------

void ShowMessage(char *str)
{
	if (!Board->show_msg)
	return;
	
	GrayDrawStr2B(0,0,str,A_REPLACE,GetPlane(0),GetPlane(1));
	ngetchx();
}
//-----------------------------------------------------------------------------

void RefreshScreen(void)
{
	unsigned short *src;
	char *P;
	
	GrayClearScreen2B(Plane0,Plane1);
	
	FastDrawVLine(Plane1,9,0,99,A_OR); // (1*9) = 9
	FastDrawVLine(Plane1,64,0,99,A_OR); // (7*9)+1 = 64
	FastDrawVLine(Plane1,74,0,99,A_OR); // (8*9)+2 = 74
	FastDrawVLine(Plane1,129,0,99,A_OR); // (14*9)+3 = 129
	
	// dices_data
	
	
	src=dices_data+16*(Board->Dices[0]-1);
	P=(Board->DiceNum[0]<=0?Plane0:Plane1);
	GraySprite16_OR(130,0,16,src,src,Plane0,P);
	
	src=dices_data+16*(Board->Dices[1]-1);
	P=(Board->DiceNum[1]<=0?Plane0:Plane1);
	GraySprite16_OR(130,16,16,src,src,Plane0,P);
	
	// DiceNum
	
	char ch1=(Board->DiceNum[0]>0?'0'+Board->DiceNum[0]:' ');
	GrayDrawChar2B(146,0,ch1,A_NORMAL,Plane0,Plane1);
	char ch2=(Board->DiceNum[1]>0?'0'+Board->DiceNum[1]:' ');
	GrayDrawChar2B(146,16,ch2,A_NORMAL,Plane0,Plane1);
	
	
	// Board->turn
	
	
	src=tiles_Data+9;
	GraySprite16_MASK(130,40,9,src,src+27,tiles_Data+18,tiles_Data+18,Plane0,Plane1);
	src=tiles_Data;
	GraySprite16_MASK(130,50,9,src,src+27,tiles_Data+18,tiles_Data+18,Plane0,Plane1);
	
	
	int y=(Board->turn?40:50);
	GraySprite8_OR(140,y+2,5,Tile_Cross,Tile_Cross,Plane0,Plane1);
	
	
	int f;
	for (f=0;f<28;f++)
	{
		int x=GetFlecheX(f);
		int y=GetFlecheYY(f)?0:55;
		
		// fleche_data
		src=GetFlecheYY(f)?fleche_data:fleche_data+45;
		if (f!=0 && f!=7 && f!=20 && f!=27)
		GraySprite16_OR(x,y,45,src,src+90,Plane0,Plane1);
		
		// Draw Pions
		
		int yy=GetFlecheYY(f)?0:91;
		
		int count1=Board->Fleches[f].Count[0];
		int count2=Board->Fleches[f].Count[1];
		
		int count = count1?count1:count2;
		src=count1?tiles_Data:tiles_Data+9;
		
		int a;
		for (a=0;a<count;a++)
		{
			GraySprite16_MASK(x,yy,9,src,src+27,tiles_Data+18,tiles_Data+18,Plane0,Plane1);
			int y_step=(count>5?36/(count-1):9);
			yy+=(GetFlecheYY(f)?y_step:-y_step);
		}
		
	}
	
	// cursor_data
	int f2=Board->cursor_pos;
	GraySprite16_XOR(GetFlecheX(f2),(GetFlecheYY(f2)?0:55),45,cursor_data,cursor_data,Plane0,Plane1);
	
	
	
	// Tile_Round
	
	if (Board->move_step==1)
	{
		int f=Board->move_src;
		GraySprite8_OR(GetFlecheX(f)+2,(GetFlecheYY(f)?45:50),5,Tile_Round,Tile_Round,Plane0,Plane1);
	}
	
	// Valid Moves
	
	//int DestCount=0;
	int srci=(Board->move_step==1?Board->move_src:Board->cursor_pos);
	
	int a;
	for (a=0;a<Board->ValidMoves.Count;a++)
	{
		TValidMove*vm=&Board->ValidMoves.ValidMove[a];
		if (vm->src==srci)
		{
			int f=vm->dest;
			GraySprite8_OR(GetFlecheX(f)+2,(GetFlecheYY(f)?45:50),5,Tile_Cross,Tile_Cross,Plane0,Plane1);
			//DestCount++;
		}
	}
	
	// DestCount : DEBUG
	//char ch='0'+DestCount;
	//GrayDrawChar2B(130,70,ch,A_NORMAL,Plane0,Plane1);
	
	
	// Copy Screen
	FastCopyScreen(Plane0,GetPlane(0));
	FastCopyScreen(Plane1,GetPlane(1));
	
}
//-----------------------------------------------------------------------------

// Main Function
void _main(void)
{
	
	TMenu MenuA;
	Menu = &MenuA;
	
	TBoard BoardA;
	Board=&BoardA;
	
	Plane0=malloc(2*LCD_SIZE);
	Plane1=Plane0+LCD_SIZE;
	
	randomize();
	
	
	// options
	Board->show_msg=1;
	Board->cc_delay=1;
	Board->AI_Computers[0]=0;
	Board->AI_Computers[1]=1;
	
	
	for (;;)
	{
		
		MenuNew2();
		MenuAddTitle("BackGammon");
		MenuAddItem("Play");
		MenuAddItem("Options");
		MenuAddItem("About");
		MenuAddItem("Quit");
		
		MenuDo(ME_MAIN);
		
		if (!Menu->ok) break;
		
		if (Menu->Index==1)
		{
			
			
			NewGame();
			
			GrayOn();
			
			for (;;)
			{
				
				RefreshScreen();
				
				if (!Board->win_state)
				{
					
					
					if (Board->AI_Computers[Board->turn])
					{
						
						if (kbhit())
						if (ngetchx()==KEY_ESC)
						{
							Board->AI_Computers[0]=0;
							Board->AI_Computers[1]=0;
							continue;
						}
						
						// NO MOVES AVAILABLE
						if (!Board->ValidMoves.Count)
						{
							CC_Wait(500);
							OnSkipTurn();
							continue;
						}
						
						// CPU PLAYS RANDOMLY
						int r=random(Board->ValidMoves.Count);
						TValidMove*vm=&Board->ValidMoves.ValidMove[r];
						
						Board->move_step=0;
						
						CC_MoveCursor(vm->src);
						
						CC_Wait(300);
						OnPressF1();
						RefreshScreen();
						CC_Wait(500);
						
						CC_MoveCursor(vm->dest);
						
						CC_Wait(300);
						OnPressF1();
						RefreshScreen();
						//CC_Wait(500);
						
						continue;
					}
				
				}
				
				int key=ngetchx();
				
				if (key==KEY_LEFT)
				{
					if (Board->cursor_pos<=13)
					{
						Board->cursor_pos--;
						if (Board->cursor_pos<0)
						Board->cursor_pos=13;
					}
					else
					{
						Board->cursor_pos++;
						if (Board->cursor_pos>27)
						Board->cursor_pos=14;
					}
				}
				else if (key==KEY_RIGHT)
				{
					if (Board->cursor_pos<=13)
					{
						Board->cursor_pos++;
						if (Board->cursor_pos>13)
						Board->cursor_pos=0;
					}
					else
					{
						Board->cursor_pos--;
						if (Board->cursor_pos<14)
						Board->cursor_pos=27;
					}
				}
				else if (key==KEY_UP || key==KEY_DOWN)
				Board->cursor_pos=27-Board->cursor_pos;
				
				else if (key==KEY_F1)
				OnPressF1();
				
				else if (key==KEY_F2)
				NewGame();
				
				else if (key==KEY_F3)
				Board->AI_Computers[Board->turn]^=1;

				else if (key==KEY_CLEAR)
				OnSkipTurn();
				
				else if (key==KEY_APPS)
				off();
				
				else if (key==KEY_ESC)
				{
					GrayOff();
					MenuNew2();
					MenuAddTitle("Exit Game?");
					MenuAddItem("Yes");
					MenuAddItem("No");
					MenuDo(ME_PAUSE);
					GrayOn();
					
					if (Menu->ok && Menu->Index==1)
					break;
					
				}
				
				
			}
			
			GrayOff();
			
			
		}
		else if (Menu->Index==2)
		{
			
			char buffer[50];
			
			for (;;)
			{
				
				MenuNew2();
				MenuAddTitle("Options");
				sprintf(buffer,"Player1 : %s",player_str[Board->AI_Computers[0]]);
				MenuAddItem(buffer);
				sprintf(buffer,"Player2 : %s",player_str[Board->AI_Computers[1]]);
				MenuAddItem(buffer);
				sprintf(buffer,"Messages : %s",yesno_str[Board->show_msg]);
				MenuAddItem(buffer);
				sprintf(buffer,"Delays : %s",yesno_str[Board->cc_delay]);
				MenuAddItem(buffer);
				
				
				MenuDo(ME_OPTIONS);
				
				if (!Menu->ok) break;
				
				if (Menu->Index==1)
				Board->AI_Computers[0]^=1;
				else if (Menu->Index==2)
				Board->AI_Computers[1]^=1;
				else if (Menu->Index==3)
				Board->show_msg^=1;
				else if (Menu->Index==4)
				Board->cc_delay^=1;
				
			}
		}
		else if (Menu->Index==3)
		{
			FontSetSys(0);
			clrscr();
			printf("About \n");
			printf("BackGammon 1.0 \n");
			printf("Programmed by Olivier Sangala \n");
			printf("http://olivier.sangala.free.fr \n");
			printf("olivier_sangala@hotmail.com \n");
			FontSetSys(1);
			ngetchx();
			
		}
		else
		break;
		
	}
	
	if (Plane0)
	free(Plane0);
}
