//-----------------------------------------------------------------------------
/*
Programmed by Olivier Sangala
http://olivier.sangala.free.fr
olivier_sangala@hotmail.com
*/
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------

#define FL_BAR0 (7)
#define FL_BAR1 (20)

//-----------------------------------------------------------------------------

enum {C_BLUE,C_WHITE};

//-----------------------------------------------------------------------------

typedef struct
{
	int Count[2];
}
TFleche;

typedef struct
{
	int src;
	int dest;
	int DiceCount[2];
	int hit;
}
TValidMove;

typedef struct
{
	TValidMove ValidMove[64];
	int Count;
}
TValidMoves;

typedef struct
{
	TFleche Fleches[28];
	TValidMoves ValidMoves;
	
	int turn;
	int cursor_pos;
	
	int Dices[2];
	int DiceNum[2];
	
	int JanCount[2];
	int BearOff_LePlusLoin[2];
	
	// Current Move
	int move_step;
	int move_src;
	int move_dest;
	
	int win_state;
	
	// options
	int AI_Computers[2];
	int show_msg;
	int cc_delay;
	
}
TBoard;

//-----------------------------------------------------------------------------

void WaitForMillis(unsigned short n);
void CC_Wait(int n);

void NewGame(void);
void RollDices(void);

void GetValidMoves(void);
void GetValidDests(int f1);
void AddValidMove(int f1, int dc0, int dc1);

int AddToFleche(int f, int d);
TValidMove* GetValidMove(int src, int dest);
void MovePiece(int src, int dest);
void BeginTurn(void);
void BeginNewMove(void);


int GetFlecheX(int f);
int GetFlecheYY(int f);

void OnPressF1(void);
void OnSkipTurn(void);
void CC_MoveCursor(int f2);

void ShowMessage(char *str);
void RefreshScreen(void);

//-----------------------------------------------------------------------------
